Imports Microsoft.VisualBasic
Imports System.Data
Imports System.Data.SQLClient
Imports System.Configuration
Imports System.Web.UI.Page
Imports System.Web.HttpRequest

Public Class DBLayer
	Inherits System.Web.UI.Page

	Public Sub getConnection(ByRef oConn As SqlConnection)
		oConn = New SqlConnection(ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString)
		oConn.Open()
	End Sub

	Public Sub GetExecuteNonQuery(ByVal strSQL As String)
		Dim intNoOfRows As Integer
		Dim oConnection As SqlConnection = Nothing
		getConnection(oConnection)
		Dim oCommand As New SqlCommand(strSQL, oConnection)
		oCommand.CommandTimeout = 3600
		Try
			intNoOfRows = oCommand.ExecuteNonQuery()
		Finally
			oConnection.Close()
			oConnection.Dispose()
		End Try
	End Sub

	Public Function GetExecuteNonQueryTransaction(ByVal strSQL As String) As Boolean
		Dim intNoOfRows As Integer
		Dim oConnection As SqlConnection = Nothing
		getConnection(oConnection)
		Dim oCommand As New SqlCommand(strSQL, oConnection)
		oCommand.CommandTimeout = 3600

		Dim oTransaction As SqlTransaction = oConnection.BeginTransaction()
		oCommand.Transaction = oTransaction
		Try
			intNoOfRows = oCommand.ExecuteNonQuery()
			'Commit the transaction
			oTransaction.Commit()
			Return True
		Catch e As Exception
			Dim str As String = e.Message
			'Rollback the transaction
			oTransaction.Rollback()
			Return False
		Finally
			oConnection.Close()
			oConnection.Dispose()
		End Try
	End Function

	Public Overloads Sub GetExecuteNonQueryFromStoredProc(ByVal oCommand As SqlCommand)
		Dim oConnection As SqlConnection = Nothing
		getConnection(oConnection)
		oCommand.Connection = oConnection
		oCommand.CommandType = CommandType.StoredProcedure
		oCommand.CommandTimeout = 3600
		Try
			oCommand.ExecuteNonQuery()
		Finally
			oConnection.Close()
			oConnection.Dispose()
		End Try
	End Sub

	Public Overloads Sub GetExecuteNonQueryFromStoredProc(ByVal ProcedureName As String)
		Dim oConnection As SqlConnection = Nothing
		getConnection(oConnection)
		Try
			Dim oCommand As New SqlCommand(ProcedureName, oConnection)
			oCommand.CommandType = CommandType.StoredProcedure
			oCommand.CommandTimeout = 3600
			oCommand.ExecuteNonQuery()
		Finally
			oConnection.Close()
			oConnection.Dispose()
		End Try
	End Sub

	Public Function GetExecuteNonQueryFromStoredProcTransaction(ByVal oCommand As SqlCommand) As Boolean
		Dim oConnection As SqlConnection = Nothing
		getConnection(oConnection)
		oCommand.Connection = oConnection
		oCommand.CommandType = CommandType.StoredProcedure
		oCommand.CommandTimeout = 3600
		Dim oTransaction As SqlTransaction = oConnection.BeginTransaction()
		oCommand.Transaction = oTransaction

		Try
			oCommand.ExecuteNonQuery()
			'Commit the transaction
			oTransaction.Commit()
			Return True

		Catch e As Exception
			Dim str As String = e.Message
			'Rollback the transaction
			oTransaction.Rollback()
			Return False
		Finally
			oConnection.Close()
			oConnection.Dispose()
		End Try
	End Function

	Public Overloads Function GetScalarValue(ByVal strSQL As String) As String
		Dim oConnection As SqlConnection = Nothing
		getConnection(oConnection)
		Try
			Dim oCommand As New SqlCommand(strSQL, oConnection)
			Dim obj As Object = oCommand.ExecuteScalar()
			oConnection.Close()
			If obj Is Nothing Then
				Return ""
			Else
				Return obj.ToString()
			End If
		Catch
			Return ""
		Finally
			oConnection.Close()
			oConnection.Dispose()
		End Try
	End Function

	Public Overloads Function GetScalarValue(ByVal oCmd As SqlCommand) As String
		Dim oConnection As SqlConnection = Nothing
		getConnection(oConnection)
		Try
			oCmd.Connection = oConnection
			oCmd.CommandType = CommandType.StoredProcedure
			Dim obj As Object = oCmd.ExecuteScalar()
			If obj Is Nothing Then
				Return ""
			Else
				Return obj.ToString()
			End If
		Catch
			Return ""
		Finally
			oConnection.Close()
			oConnection.Dispose()
		End Try
	End Function

	Public Function GetDataSet(ByVal strSQL As String) As DataSet
		Dim oConnection As SqlConnection = Nothing
		getConnection(oConnection)
		Dim oDataSet As New DataSet
		Try
			Dim oCommand As New SqlCommand(strSQL, oConnection)
			oCommand.CommandTimeout = 3600
			Dim oAdapter As New SqlDataAdapter(oCommand)
			oAdapter.Fill(oDataSet)
			oConnection.Close()
			Return oDataSet
		Catch
			Return Nothing
		Finally
			oConnection.Close()
			oConnection.Dispose()
		End Try
	End Function

	Public Function GetDataTable(ByVal strSQL As String) As DataTable

		Dim oConnection As SqlConnection = Nothing
		getConnection(oConnection)
		Dim oDataTable As New DataTable
		Try
			Dim oCommand As New SqlCommand(strSQL, oConnection)
			oCommand.CommandTimeout = 3600

			Dim oAdapter As New SqlDataAdapter(oCommand)
			oAdapter.Fill(oDataTable)

			Return oDataTable
		Catch
			Return Nothing
		Finally
			oConnection.Close()
			oConnection.Dispose()
		End Try
	End Function

	Public Overloads Function GetDataSetFromStoredProcedure(ByVal ProcedureName As String) As DataSet
		Dim oConnection As SqlConnection = Nothing
		getConnection(oConnection)
		Dim oDataSet As New DataSet
		Try
			Dim oCommand As New SqlCommand(ProcedureName, oConnection)
			oCommand.CommandType = CommandType.StoredProcedure
			oCommand.CommandTimeout = 3600

			Dim oAdapter As New SqlDataAdapter(oCommand)
			oAdapter.Fill(oDataSet)
			oConnection.Close()
			Return oDataSet
		Catch
			Return Nothing
		Finally
			oConnection.Close()
			oConnection.Dispose()
		End Try
	End Function

	Public Overloads Function GetDataSetFromStoredProcedure(ByVal ProcedureName As String, ByVal oCommand As SqlCommand) As DataSet
		Dim oConnection As SqlConnection = Nothing
		getConnection(oConnection)
		Dim oDataSet As New DataSet
		Try
			oCommand.CommandText = ProcedureName
			oCommand.CommandType = CommandType.StoredProcedure
			oCommand.Connection = oConnection
			oCommand.CommandTimeout = 3600

			Dim oAdapter As New SqlDataAdapter(oCommand)
			oAdapter.Fill(oDataSet)
			oConnection.Close()
			Return oDataSet
		Catch
			Return Nothing
		Finally
			oConnection.Close()
			oConnection.Dispose()
		End Try
	End Function

	Public Overloads Function GetDataSetFromStoredProcedure(ByVal oCommand As SqlCommand) As DataSet
		Dim oConnection As SqlConnection = Nothing
		getConnection(oConnection)
		Dim oDataSet As New DataSet
		Try
			oCommand.CommandType = CommandType.StoredProcedure
			oCommand.CommandTimeout = 3600
			oCommand.Connection = oConnection
			Dim oAdapter As New SqlDataAdapter(oCommand)
			oAdapter.Fill(oDataSet)
			oConnection.Close()
			Return oDataSet
		Catch ex As Exception
			Return Nothing
		Finally
			oConnection.Close()
			oConnection.Dispose()
		End Try
	End Function

	Public Function GetDataReader(ByVal strSQL As String) As SqlDataReader
		Dim oConnection As SqlConnection = Nothing
		getConnection(oConnection)
		Try
			Dim oCommand As New SqlCommand(strSQL, oConnection)
			Return oCommand.ExecuteReader(CommandBehavior.CloseConnection)
		Catch
			Return Nothing
		Finally
			oConnection.Close()
			oConnection.Dispose()
		End Try
	End Function

	Public Overloads Function GetDataReaderFromStoredProcedure(ByVal ProcedureName As String, ByVal oCommand As SqlCommand) As SqlDataReader
		Dim oConnection As SqlConnection = Nothing
		getConnection(oConnection)
		Try
			oCommand.CommandType = CommandType.StoredProcedure
			oCommand.Connection = oConnection
			Return oCommand.ExecuteReader(CommandBehavior.CloseConnection)
		Catch
			Return Nothing
		Finally
			oConnection.Close()
			oConnection.Dispose()
		End Try
	End Function

	Public Overloads Function GetDataTableFromStoredProcedure(ByVal oCommand As SqlCommand) As DataTable
		Dim oConnection As SqlConnection = Nothing
		getConnection(oConnection)
		Dim oDataTable As New DataTable
		Try
			oCommand.CommandType = CommandType.StoredProcedure
			oCommand.CommandTimeout = 3600
			oCommand.Connection = oConnection

			Dim oAdapter As New SqlDataAdapter(oCommand)
			oAdapter.Fill(oDataTable)
			oConnection.Close()
			Return oDataTable
		Catch
			Return Nothing
		Finally
			oConnection.Close()
			oConnection.Dispose()
		End Try
	End Function

	Public Overloads Function GetDataTableFromStoredProcedure(ByVal ProcedureName As String) As DataTable
		Dim oCommand As SqlCommand
		Dim oConnection As SqlConnection = Nothing
		getConnection(oConnection)
		Dim oDataTable As New DataTable
		Try
			oCommand = New SqlCommand(ProcedureName)
			oCommand.CommandType = CommandType.StoredProcedure
			oCommand.CommandTimeout = 3600
			oCommand.Connection = oConnection

			Dim oAdapter As New SqlDataAdapter(oCommand)
			oAdapter.Fill(oDataTable)
			oConnection.Close()
			Return oDataTable
		Catch
			Return Nothing
		Finally
			oConnection.Close()
			oConnection.Dispose()
		End Try
	End Function

	Public Overloads Function GetDataRowFromStoredProcedure(ByVal oCommand As SqlCommand) As DataRow
		Dim oConnection As SqlConnection = Nothing
		getConnection(oConnection)
		Dim oDataSet As New DataSet
		Try
			oCommand.CommandType = CommandType.StoredProcedure
			oCommand.CommandTimeout = 3600
			oCommand.Connection = oConnection

			Dim oAdapter As New SqlDataAdapter(oCommand)
			oAdapter.Fill(oDataSet)
			oConnection.Close()
			Return oDataSet.Tables(0).Rows(0)
		Catch
			Return Nothing
		Finally
			oConnection.Close()
			oConnection.Dispose()
		End Try
	End Function

	Public Overloads Function GetDataReaderFromStoredProcedure(ByVal ProcedureName As String) As SqlDataReader
		Dim oConnection As SqlConnection = Nothing
		getConnection(oConnection)
		Try
			Dim oCommand As New SqlCommand(ProcedureName, oConnection)
			oCommand.CommandType = CommandType.StoredProcedure
			Return oCommand.ExecuteReader(CommandBehavior.CloseConnection)
		Catch
			Return Nothing
		Finally
			oConnection.Close()
			oConnection.Dispose()
		End Try
	End Function

	Public Sub saveDataSet(ByVal strQuery As String, ByVal ds As DataSet, ByVal tblName As String, Optional ByVal insertCommand As Boolean = True, Optional ByVal deleteCommand As Boolean = True, Optional ByVal updateCommand As Boolean = True)
		Dim da As SqlDataAdapter = Nothing
		Dim oConnection As SqlConnection = Nothing
		getConnection(oConnection)
		Try
			Dim cb As New SqlCommandBuilder
			da = New SqlDataAdapter(strQuery, oConnection)
			cb.DataAdapter = da

			If insertCommand Then da.InsertCommand = cb.GetInsertCommand
			If deleteCommand Then da.DeleteCommand = cb.GetDeleteCommand
			If updateCommand Then da.UpdateCommand = cb.GetUpdateCommand

			da.Update(ds, tblName)
		Catch Ex As Exception
			Throw Ex
		Finally
			oConnection.Close()
			oConnection.Dispose()
			If Not da Is Nothing Then da.Dispose()
		End Try
	End Sub

	Public Sub saveDataTable(ByVal sQuery As String, ByVal tbl As DataTable, Optional ByVal insertCommand As Boolean = True, Optional ByVal deleteCommand As Boolean = True, Optional ByVal updateCommand As Boolean = True)
		Try
			Dim dsGeneral As New DataSet
			dsGeneral.Tables.Add(tbl)
			saveDataSet(sQuery, dsGeneral, tbl.TableName, insertCommand, deleteCommand, updateCommand)
			dsGeneral.Tables.Remove(tbl)
			dsGeneral.Dispose()
		Catch Ex As Exception
			ClientScript.RegisterStartupScript([GetType], "", "<script> alert('" & Ex.Message & "'); </script>")
		End Try
	End Sub

	Public Function hasRows(ByVal ds As DataSet) As Boolean
		If IsNothing(ds) Then Return False
		If ds.Tables.Count <= 0 Then Return False
		If ds.Tables(0).Rows.Count <= 0 Then Return False
		Return True
	End Function

	Public Sub DeleteRecords(ByVal strTablename As String, ByVal strColumnName As String, ByVal strColumnValue As String)
		Dim strSql As String
		strSql = "delete " & strTablename & " WHERE " & strColumnName & " = " & strColumnValue
		GetExecuteNonQuery(strSql)
	End Sub

End Class
