﻿Imports System.Data
Imports System.Data.SqlClient
Imports Infragistics.Web
Imports Infragistics.Web.UI.GridControls
Imports Infragistics.Web.UI.ListControls

Partial Class DataEdit
	Inherits System.Web.UI.Page
	Dim objDBLayer As New DBLayer
	Dim sGrid As String
	Dim iGrid As Integer
	Shared dtKey(9) As String

	Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
		sGrid = Request.QueryString("grid")
		iGrid = Switch(sGrid = "Grades", 1, _
		 sGrid = "Structures", 2, _
		 sGrid = "Salary Structures", 3, _
		 sGrid = "Company Jobs", 4, _
		 sGrid = "Employees", 5, _
		 sGrid = "Composites", 6, _
		 sGrid = "Surveys", 7, _
		 sGrid = "Survey Jobs", 8, _
		 sGrid = "Market Data", 9)
		Header.Title = sGrid

		If Not IsPostBack Then CreateColumns()
		Dim dataList As DataSet = GetDataSource()
		grdEdit.DataSource = dataList
		grdEdit.DataKeyFields = dtKey(iGrid)
		grdEdit.DataBind()

	End Sub

	Function GetDataSource() As DataSet
		Dim dataList As DataSet
		dataList = objDBLayer.GetDataSetFromStoredProcedure("sp" & Request.QueryString("sp"))
		dataList.Tables(0).PrimaryKey = New DataColumn() {dataList.Tables(0).Columns(0)}
		dtKey(iGrid) = dataList.Tables(0).Columns(0).Caption
		Return dataList
	End Function

	Sub CreateColumns()
		Dim iBand As Integer
		Dim row As DataRow
		Dim field As BoundDataField
		Dim editSettings As EditingColumnSetting
		Dim dtList As DataTable

		If sGrid = "Salary Structures" Or sGrid = "Employees" Or sGrid = "Composites" Or sGrid = "Market Data" Then grdEdit.Behaviors.Selection.RowSelectType = Infragistics.Web.UI.GridControls.SelectType.Multiple

		Dim sSQL As String = "SELECT CXFields.*, U.bVisible, U.iWidth AS uWidth, CASE WHEN U.iPosWeb IS NULL THEN CXFields.iVisiblePos ELSE U.iPosWeb END AS uPosition"
		sSQL = sSQL & " FROM CXFields LEFT OUTER JOIN (SELECT GridColumns.vGridName, GridColumns.vGridColumn, GridLayout.* FROM GridColumns INNER JOIN GridLayout ON GridColumns.iGridColID = GridLayout.iGridColID"
		sSQL = sSQL & " WHERE GridLayout.iUserID = " & Session("UserID") & ") AS U ON CXFields.vGridName = U.vGridName AND CXFields.vFieldKey = U.vGridColumn"
		sSQL = sSQL & " WHERE CXFields.vGridName = '" & sGrid & "' ORDER BY uPosition, CXFields.iCXFieldID"
		Dim tbl As DataTable = objDBLayer.GetDataTable(sSQL)

		For Each row In tbl.Rows
			iBand = row("iBand")
			field = New BoundDataField
			field.Key = row("vFieldKey")
			field.Hidden = row("bHidden")
			field.DataFieldName = row("vFieldKey")
			If Not IsDBNull(row("vFieldName")) Then field.Header.Text = row("vFieldName")
			If Not IsDBNull(row("vToolTip")) Then field.Header.Tooltip = row("vToolTip")
			If Not IsDBNull(row("uPosition")) Then
				If row("uPosition") < 9999 Then field.VisibleIndex = row("uPosition")
			End If
			field.Width = 100
			If Not IsDBNull(row("iWidth")) Then field.Width = CInt(row("iWidth"))
			If Not IsDBNull(row("uWidth")) Then field.Width = CInt(row("uWidth"))
			grdEdit.Columns.Add(field)

			editSettings = New EditingColumnSetting
			editSettings.ColumnKey = row("vFieldKey")
			If Not IsDBNull(row("bEditable")) Then editSettings.ReadOnly = Not row("bEditable")
			If Not IsDBNull(row("vFieldType")) Then
				Select Case row("vFieldType")
					Case "Date"
						Dim datePicker As New DatePickerProvider
						datePicker.ID = row("vFieldKey")
						grdEdit.EditorProviders.Add(datePicker)
						editSettings.EditorID = row("vFieldKey")
					Case "Number"
						'add code for numeric editor
					Case "Percent"
						'add code for percent editor
					Case "Select"
						Select Case row("vFieldKey")
							Case "iCoJobID"
							Case "iGradeID"
								Dim ddlGrade As New DropDownProvider
								ddlGrade.ID = row("vFieldKey")
								ddlGrade.EditorControl.DisplayMode = DropDownDisplayMode.DropDownList
								ddlGrade.EditorControl.EditorID = row("vFieldKey")
								ddlGrade.EditorControl.EnableAutoCompleteFirstMatch = True
								dtList = objDBLayer.GetDataTable("SELECT iGradeID, vGradeName FROM Grade ORDER BY vGradeName")
								ddlGrade.EditorControl.DataSource = dtList
								ddlGrade.EditorControl.DataBind()
								ddlGrade.EditorControl.TextField = "vGradeName"
								ddlGrade.EditorControl.ValueField = "iGradeID"
								ddlGrade.EditorControl.ValueDisplayType = DropDownValueDisplayType.WebTextEditor
								grdEdit.EditorProviders.Add(ddlGrade)
								editSettings.EditorID = row("vFieldKey")
							Case "iStructureID"
							Case "iSurveyID"
							Case "iSvyJobID"
						End Select
				End Select
			End If
			grdEdit.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(editSettings)
		Next
	End Sub

End Class
